/* Notifications.c generated by valac 0.56.17, the Vala compiler
 * generated from Notifications.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 2 -*-
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: Michael Terry
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <glib/gi18n-lib.h>
#include <gtk/gtk.h>
#include "deja.h"

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_NOTIFICATIONS (notifications_get_type ())
#define NOTIFICATIONS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NOTIFICATIONS, Notifications))
#define NOTIFICATIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NOTIFICATIONS, NotificationsClass))
#define IS_NOTIFICATIONS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NOTIFICATIONS))
#define IS_NOTIFICATIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NOTIFICATIONS))
#define NOTIFICATIONS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NOTIFICATIONS, NotificationsClass))

typedef struct _Notifications Notifications;
typedef struct _NotificationsClass NotificationsClass;
typedef struct _NotificationsPrivate NotificationsPrivate;
enum  {
	NOTIFICATIONS_0_PROPERTY,
	NOTIFICATIONS_NUM_PROPERTIES
};
static GParamSpec* notifications_properties[NOTIFICATIONS_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _Notifications {
	GObject parent_instance;
	NotificationsPrivate * priv;
};

struct _NotificationsClass {
	GObjectClass parent_class;
};

static gpointer notifications_parent_class = NULL;

VALA_EXTERN GType notifications_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Notifications, g_object_unref)
VALA_EXTERN void notifications_automatic_backup_started (void);
static void notifications_send_status (const gchar* title,
                                const gchar* body,
                                GNotificationPriority priority);
VALA_EXTERN void notifications_automatic_backup_delayed (const gchar* reason);
VALA_EXTERN void notifications_backup_finished (GtkWidget* parent,
                                    gboolean success,
                                    gboolean cancelled,
                                    const gchar* detail);
static gboolean notifications_window_is_active (GtkWidget* parent);
VALA_EXTERN gboolean snap_banner_should_warn (void);
static void notifications_withdraw_status (void);
VALA_EXTERN void notifications_restore_finished (GtkWidget* parent,
                                     gboolean success,
                                     gboolean cancelled,
                                     const gchar* detail);
VALA_EXTERN void notifications_operation_blocked (GtkWidget* parent,
                                      const gchar* title,
                                      const gchar* body);
VALA_EXTERN void notifications_operation_unblocked (void);
VALA_EXTERN void notifications_attention_needed (GtkWidget* parent,
                                     const gchar* title,
                                     const gchar* body);
VALA_EXTERN void notifications_prompt (void);
static GNotification* notifications_make_note (const gchar* title,
                                        const gchar* body);
VALA_EXTERN void notifications_close_all (void);
VALA_EXTERN Notifications* notifications_new (void);
VALA_EXTERN Notifications* notifications_construct (GType object_type);
static GType notifications_get_type_once (void);

void
notifications_automatic_backup_started (void)
{
#line 13 "../app/Notifications.vala"
	notifications_send_status (_ ("Starting scheduled backup"), NULL, G_NOTIFICATION_PRIORITY_LOW);
#line 105 "Notifications.c"
}

void
notifications_automatic_backup_delayed (const gchar* reason)
{
#line 16 "../app/Notifications.vala"
	g_return_if_fail (reason != NULL);
#line 18 "../app/Notifications.vala"
	notifications_send_status (_ ("Scheduled backup delayed"), reason, G_NOTIFICATION_PRIORITY_NORMAL);
#line 115 "Notifications.c"
}

void
notifications_backup_finished (GtkWidget* parent,
                               gboolean success,
                               gboolean cancelled,
                               const gchar* detail)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 21 "../app/Notifications.vala"
	g_return_if_fail (parent != NULL);
#line 24 "../app/Notifications.vala"
	if (!notifications_window_is_active (parent)) {
#line 24 "../app/Notifications.vala"
		_tmp1_ = success;
#line 132 "Notifications.c"
	} else {
#line 24 "../app/Notifications.vala"
		_tmp1_ = FALSE;
#line 136 "Notifications.c"
	}
#line 24 "../app/Notifications.vala"
	if (_tmp1_) {
#line 24 "../app/Notifications.vala"
		_tmp0_ = !cancelled;
#line 142 "Notifications.c"
	} else {
#line 24 "../app/Notifications.vala"
		_tmp0_ = FALSE;
#line 146 "Notifications.c"
	}
#line 24 "../app/Notifications.vala"
	if (_tmp0_) {
#line 150 "Notifications.c"
		gchar* title = NULL;
		gchar* _tmp2_;
		GNotificationPriority priority = 0;
		gchar* body = NULL;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
#line 25 "../app/Notifications.vala"
		_tmp2_ = g_strdup (_ ("Backup completed"));
#line 25 "../app/Notifications.vala"
		title = _tmp2_;
#line 26 "../app/Notifications.vala"
		priority = G_NOTIFICATION_PRIORITY_LOW;
#line 28 "../app/Notifications.vala"
		body = NULL;
#line 29 "../app/Notifications.vala"
		if (detail != NULL) {
#line 167 "Notifications.c"
			gchar* _tmp3_;
			gchar* _tmp4_;
#line 30 "../app/Notifications.vala"
			_tmp3_ = g_strdup (_ ("Backup finished"));
#line 30 "../app/Notifications.vala"
			_g_free0 (title);
#line 30 "../app/Notifications.vala"
			title = _tmp3_;
#line 31 "../app/Notifications.vala"
			_tmp4_ = g_strdup (_ ("But not all files were successfully backed up."));
#line 31 "../app/Notifications.vala"
			_g_free0 (body);
#line 31 "../app/Notifications.vala"
			body = _tmp4_;
#line 32 "../app/Notifications.vala"
			priority = G_NOTIFICATION_PRIORITY_NORMAL;
#line 184 "Notifications.c"
		} else {
#line 34 "../app/Notifications.vala"
			if (snap_banner_should_warn ()) {
#line 188 "Notifications.c"
				gchar* _tmp5_;
#line 35 "../app/Notifications.vala"
				_tmp5_ = g_strdup (_ ("This snap release is deprecated and might not receive updates."));
#line 35 "../app/Notifications.vala"
				_g_free0 (body);
#line 35 "../app/Notifications.vala"
				body = _tmp5_;
#line 196 "Notifications.c"
			}
		}
#line 38 "../app/Notifications.vala"
		_tmp6_ = title;
#line 38 "../app/Notifications.vala"
		_tmp7_ = body;
#line 38 "../app/Notifications.vala"
		notifications_send_status (_tmp6_, _tmp7_, priority);
#line 24 "../app/Notifications.vala"
		_g_free0 (body);
#line 24 "../app/Notifications.vala"
		_g_free0 (title);
#line 209 "Notifications.c"
	} else {
		gboolean _tmp8_ = FALSE;
		gboolean _tmp9_ = FALSE;
#line 40 "../app/Notifications.vala"
		if (!notifications_window_is_active (parent)) {
#line 40 "../app/Notifications.vala"
			_tmp9_ = !success;
#line 217 "Notifications.c"
		} else {
#line 40 "../app/Notifications.vala"
			_tmp9_ = FALSE;
#line 221 "Notifications.c"
		}
#line 40 "../app/Notifications.vala"
		if (_tmp9_) {
#line 40 "../app/Notifications.vala"
			_tmp8_ = !cancelled;
#line 227 "Notifications.c"
		} else {
#line 40 "../app/Notifications.vala"
			_tmp8_ = FALSE;
#line 231 "Notifications.c"
		}
#line 40 "../app/Notifications.vala"
		if (_tmp8_) {
#line 41 "../app/Notifications.vala"
			notifications_send_status (_ ("Backup failed"), NULL, G_NOTIFICATION_PRIORITY_NORMAL);
#line 237 "Notifications.c"
		} else {
#line 45 "../app/Notifications.vala"
			notifications_withdraw_status ();
#line 241 "Notifications.c"
		}
	}
}

void
notifications_restore_finished (GtkWidget* parent,
                                gboolean success,
                                gboolean cancelled,
                                const gchar* detail)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 49 "../app/Notifications.vala"
	g_return_if_fail (parent != NULL);
#line 52 "../app/Notifications.vala"
	if (!notifications_window_is_active (parent)) {
#line 52 "../app/Notifications.vala"
		_tmp1_ = !success;
#line 260 "Notifications.c"
	} else {
#line 52 "../app/Notifications.vala"
		_tmp1_ = FALSE;
#line 264 "Notifications.c"
	}
#line 52 "../app/Notifications.vala"
	if (_tmp1_) {
#line 52 "../app/Notifications.vala"
		_tmp0_ = !cancelled;
#line 270 "Notifications.c"
	} else {
#line 52 "../app/Notifications.vala"
		_tmp0_ = FALSE;
#line 274 "Notifications.c"
	}
#line 52 "../app/Notifications.vala"
	if (_tmp0_) {
#line 53 "../app/Notifications.vala"
		notifications_send_status (_ ("Restore failed"), NULL, G_NOTIFICATION_PRIORITY_NORMAL);
#line 280 "Notifications.c"
	}
}

void
notifications_operation_blocked (GtkWidget* parent,
                                 const gchar* title,
                                 const gchar* body)
{
#line 56 "../app/Notifications.vala"
	g_return_if_fail (parent != NULL);
#line 56 "../app/Notifications.vala"
	g_return_if_fail (title != NULL);
#line 59 "../app/Notifications.vala"
	if (!notifications_window_is_active (parent)) {
#line 60 "../app/Notifications.vala"
		notifications_send_status (title, body, G_NOTIFICATION_PRIORITY_NORMAL);
#line 297 "Notifications.c"
	}
}

void
notifications_operation_unblocked (void)
{
#line 65 "../app/Notifications.vala"
	notifications_withdraw_status ();
#line 306 "Notifications.c"
}

void
notifications_attention_needed (GtkWidget* parent,
                                const gchar* title,
                                const gchar* body)
{
#line 68 "../app/Notifications.vala"
	g_return_if_fail (parent != NULL);
#line 68 "../app/Notifications.vala"
	g_return_if_fail (title != NULL);
#line 71 "../app/Notifications.vala"
	if (!notifications_window_is_active (parent)) {
#line 72 "../app/Notifications.vala"
		notifications_send_status (title, body, G_NOTIFICATION_PRIORITY_HIGH);
#line 322 "Notifications.c"
	}
}

void
notifications_prompt (void)
{
	GNotification* note = NULL;
	GNotification* _tmp0_;
	GApplication* _tmp1_;
#line 77 "../app/Notifications.vala"
	deja_dup_update_prompt_time (FALSE);
#line 79 "../app/Notifications.vala"
	_tmp0_ = notifications_make_note (_ ("Keep your files safe by backing up regularly"), _ ("Important documents, data, and settings can be " "protected by storing them in a backup. In the " "case of a disaster, you would be able to recover " "them from that backup."));
#line 79 "../app/Notifications.vala"
	note = _tmp0_;
#line 84 "../app/Notifications.vala"
	g_notification_set_default_action (note, "app.prompt-ok");
#line 85 "../app/Notifications.vala"
	g_notification_add_button (note, _ ("Don’t Show Again"), "app.prompt-cancel");
#line 86 "../app/Notifications.vala"
	g_notification_add_button (note, _ ("Open Backups"), "app.prompt-ok");
#line 88 "../app/Notifications.vala"
	_tmp1_ = g_application_get_default ();
#line 88 "../app/Notifications.vala"
	g_application_send_notification (_tmp1_, "prompt", note);
#line 75 "../app/Notifications.vala"
	_g_object_unref0 (note);
#line 350 "Notifications.c"
}

void
notifications_close_all (void)
{
	GApplication* _tmp0_;
#line 93 "../app/Notifications.vala"
	notifications_withdraw_status ();
#line 94 "../app/Notifications.vala"
	_tmp0_ = g_application_get_default ();
#line 94 "../app/Notifications.vala"
	g_application_withdraw_notification (_tmp0_, "prompt");
#line 363 "Notifications.c"
}

static GNotification*
notifications_make_note (const gchar* title,
                         const gchar* body)
{
	GNotification* note = NULL;
	GNotification* _tmp0_;
	gchar* icon_env = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	GNotification* _tmp14_;
	GNotification* result;
#line 97 "../app/Notifications.vala"
	g_return_val_if_fail (title != NULL, NULL);
#line 99 "../app/Notifications.vala"
	_tmp0_ = g_notification_new (title);
#line 99 "../app/Notifications.vala"
	note = _tmp0_;
#line 100 "../app/Notifications.vala"
	if (body != NULL) {
#line 386 "Notifications.c"
		GNotification* _tmp1_;
#line 101 "../app/Notifications.vala"
		_tmp1_ = note;
#line 101 "../app/Notifications.vala"
		g_notification_set_body (_tmp1_, body);
#line 392 "Notifications.c"
	}
#line 105 "../app/Notifications.vala"
	_tmp2_ = g_getenv ("DEJA_DUP_NOTIFICATION_ICON");
#line 105 "../app/Notifications.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 105 "../app/Notifications.vala"
	icon_env = _tmp3_;
#line 106 "../app/Notifications.vala"
	_tmp4_ = icon_env;
#line 106 "../app/Notifications.vala"
	if (_tmp4_ != NULL) {
#line 404 "Notifications.c"
		GNotification* _tmp5_;
		const gchar* _tmp6_;
		GFile* _tmp7_;
		GFile* _tmp8_;
		GFileIcon* _tmp9_;
		GFileIcon* _tmp10_;
#line 107 "../app/Notifications.vala"
		_tmp5_ = note;
#line 107 "../app/Notifications.vala"
		_tmp6_ = icon_env;
#line 107 "../app/Notifications.vala"
		_tmp7_ = g_file_new_for_path (_tmp6_);
#line 107 "../app/Notifications.vala"
		_tmp8_ = _tmp7_;
#line 107 "../app/Notifications.vala"
		_tmp9_ = (GFileIcon*) g_file_icon_new (_tmp8_);
#line 107 "../app/Notifications.vala"
		_tmp10_ = _tmp9_;
#line 107 "../app/Notifications.vala"
		g_notification_set_icon (_tmp5_, (GIcon*) _tmp10_);
#line 107 "../app/Notifications.vala"
		_g_object_unref0 (_tmp10_);
#line 107 "../app/Notifications.vala"
		_g_object_unref0 (_tmp8_);
#line 429 "Notifications.c"
	} else {
		GNotification* _tmp11_;
		GThemedIcon* _tmp12_;
		GThemedIcon* _tmp13_;
#line 109 "../app/Notifications.vala"
		_tmp11_ = note;
#line 109 "../app/Notifications.vala"
		_tmp12_ = (GThemedIcon*) g_themed_icon_new (ICON_NAME);
#line 109 "../app/Notifications.vala"
		_tmp13_ = _tmp12_;
#line 109 "../app/Notifications.vala"
		g_notification_set_icon (_tmp11_, (GIcon*) _tmp13_);
#line 109 "../app/Notifications.vala"
		_g_object_unref0 (_tmp13_);
#line 444 "Notifications.c"
	}
#line 113 "../app/Notifications.vala"
	_tmp14_ = note;
#line 113 "../app/Notifications.vala"
	g_notification_set_default_action (_tmp14_, "app.show");
#line 115 "../app/Notifications.vala"
	result = note;
#line 115 "../app/Notifications.vala"
	_g_free0 (icon_env);
#line 115 "../app/Notifications.vala"
	return result;
#line 456 "Notifications.c"
}

static void
notifications_send_status (const gchar* title,
                           const gchar* body,
                           GNotificationPriority priority)
{
	GNotification* note = NULL;
	GNotification* _tmp0_;
	GApplication* _tmp1_;
#line 118 "../app/Notifications.vala"
	g_return_if_fail (title != NULL);
#line 121 "../app/Notifications.vala"
	_tmp0_ = notifications_make_note (title, body);
#line 121 "../app/Notifications.vala"
	note = _tmp0_;
#line 122 "../app/Notifications.vala"
	g_notification_set_priority (note, priority);
#line 123 "../app/Notifications.vala"
	_tmp1_ = g_application_get_default ();
#line 123 "../app/Notifications.vala"
	g_application_send_notification (_tmp1_, "backup-status", note);
#line 118 "../app/Notifications.vala"
	_g_object_unref0 (note);
#line 481 "Notifications.c"
}

static void
notifications_withdraw_status (void)
{
	GApplication* _tmp0_;
#line 128 "../app/Notifications.vala"
	_tmp0_ = g_application_get_default ();
#line 128 "../app/Notifications.vala"
	g_application_withdraw_notification (_tmp0_, "backup-status");
#line 492 "Notifications.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 133 "../app/Notifications.vala"
	return self ? g_object_ref (self) : NULL;
#line 500 "Notifications.c"
}

static gboolean
notifications_window_is_active (GtkWidget* parent)
{
	GtkWindow* win = NULL;
	GtkRoot* _tmp0_;
	GtkRoot* _tmp1_;
	GtkWindow* _tmp2_;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	GtkWindow* _tmp5_;
	gboolean result;
#line 131 "../app/Notifications.vala"
	g_return_val_if_fail (parent != NULL, FALSE);
#line 133 "../app/Notifications.vala"
	_tmp0_ = gtk_widget_get_root (parent);
#line 133 "../app/Notifications.vala"
	_tmp1_ = _tmp0_;
#line 133 "../app/Notifications.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, gtk_window_get_type ()) ? ((GtkWindow*) _tmp1_) : NULL);
#line 133 "../app/Notifications.vala"
	win = _tmp2_;
#line 134 "../app/Notifications.vala"
	_tmp5_ = win;
#line 134 "../app/Notifications.vala"
	if (_tmp5_ != NULL) {
#line 528 "Notifications.c"
		GtkWindow* _tmp6_;
		gboolean _tmp7_;
		gboolean _tmp8_;
#line 134 "../app/Notifications.vala"
		_tmp6_ = win;
#line 134 "../app/Notifications.vala"
		g_object_get (_tmp6_, "is-active", &_tmp7_, NULL);
#line 134 "../app/Notifications.vala"
		_tmp8_ = _tmp7_;
#line 134 "../app/Notifications.vala"
		_tmp4_ = _tmp8_;
#line 540 "Notifications.c"
	} else {
#line 134 "../app/Notifications.vala"
		_tmp4_ = FALSE;
#line 544 "Notifications.c"
	}
#line 134 "../app/Notifications.vala"
	if (_tmp4_) {
#line 548 "Notifications.c"
		GtkWindow* _tmp9_;
		gboolean _tmp10_;
		gboolean _tmp11_;
#line 134 "../app/Notifications.vala"
		_tmp9_ = win;
#line 134 "../app/Notifications.vala"
		_tmp10_ = gtk_widget_get_visible ((GtkWidget*) _tmp9_);
#line 134 "../app/Notifications.vala"
		_tmp11_ = _tmp10_;
#line 134 "../app/Notifications.vala"
		_tmp3_ = _tmp11_;
#line 560 "Notifications.c"
	} else {
#line 134 "../app/Notifications.vala"
		_tmp3_ = FALSE;
#line 564 "Notifications.c"
	}
#line 134 "../app/Notifications.vala"
	result = _tmp3_;
#line 134 "../app/Notifications.vala"
	_g_object_unref0 (win);
#line 134 "../app/Notifications.vala"
	return result;
#line 572 "Notifications.c"
}

Notifications*
notifications_construct (GType object_type)
{
	Notifications * self = NULL;
#line 9 "../app/Notifications.vala"
	self = (Notifications*) g_object_new (object_type, NULL);
#line 9 "../app/Notifications.vala"
	return self;
#line 583 "Notifications.c"
}

Notifications*
notifications_new (void)
{
#line 9 "../app/Notifications.vala"
	return notifications_construct (TYPE_NOTIFICATIONS);
#line 591 "Notifications.c"
}

static void
notifications_class_init (NotificationsClass * klass,
                          gpointer klass_data)
{
#line 9 "../app/Notifications.vala"
	notifications_parent_class = g_type_class_peek_parent (klass);
#line 600 "Notifications.c"
}

static void
notifications_instance_init (Notifications * self,
                             gpointer klass)
{
}

 G_GNUC_NO_INLINE static GType
notifications_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (NotificationsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) notifications_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Notifications), 0, (GInstanceInitFunc) notifications_instance_init, NULL };
	GType notifications_type_id;
	notifications_type_id = g_type_register_static (G_TYPE_OBJECT, "Notifications", &g_define_type_info, 0);
	return notifications_type_id;
}

GType
notifications_get_type (void)
{
	static gsize notifications_type_id__once = 0;
	if (g_once_init_enter (&notifications_type_id__once)) {
		GType notifications_type_id;
		notifications_type_id = notifications_get_type_once ();
		g_once_init_leave (&notifications_type_id__once, notifications_type_id);
	}
	return notifications_type_id__once;
}

