/* ResticInstance.c generated by valac 0.56.17, the Vala compiler
 * generated from ResticInstance.vala, do not modify */

/* -*- Mode: Vala; indent-tabs-mode: nil; tab-width: 2 -*-
 *
 * SPDX-License-Identifier: GPL-3.0-or-later
 * SPDX-FileCopyrightText: Michael Terry
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <json-glib/json-glib.h>
#include <glib/gi18n-lib.h>
#include "deja.h"

#define RESTIC_INSTANCE_ERROR_OUT_OF_SPACE -1
#define RESTIC_INSTANCE_ERROR_GENERIC 1
#define RESTIC_INSTANCE_ERROR_GO_RUNTIME 2
#define RESTIC_INSTANCE_ERROR_INVALID_SOURCE_DATA 3
#define RESTIC_INSTANCE_ERROR_NO_REPOSITORY 10
#define RESTIC_INSTANCE_ERROR_ALREADY_LOCKED 11
#define RESTIC_INSTANCE_ERROR_BAD_PASSWORD 12
#define RESTIC_INSTANCE_ERROR_CANCELED 130
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define TYPE_TOOL_INSTANCE (tool_instance_get_type ())
#define TOOL_INSTANCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TOOL_INSTANCE, ToolInstance))
#define TOOL_INSTANCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TOOL_INSTANCE, ToolInstanceClass))
#define IS_TOOL_INSTANCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TOOL_INSTANCE))
#define IS_TOOL_INSTANCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TOOL_INSTANCE))
#define TOOL_INSTANCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TOOL_INSTANCE, ToolInstanceClass))

typedef struct _ToolInstance ToolInstance;
typedef struct _ToolInstanceClass ToolInstanceClass;
typedef struct _ToolInstancePrivate ToolInstancePrivate;

#define TYPE_RESTIC_INSTANCE (restic_instance_get_type ())
#define RESTIC_INSTANCE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_RESTIC_INSTANCE, ResticInstance))
#define RESTIC_INSTANCE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_RESTIC_INSTANCE, ResticInstanceClass))
#define IS_RESTIC_INSTANCE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_RESTIC_INSTANCE))
#define IS_RESTIC_INSTANCE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_RESTIC_INSTANCE))
#define RESTIC_INSTANCE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_RESTIC_INSTANCE, ResticInstanceClass))

typedef struct _ResticInstance ResticInstance;
typedef struct _ResticInstanceClass ResticInstanceClass;
typedef struct _ResticInstancePrivate ResticInstancePrivate;
enum  {
	RESTIC_INSTANCE_0_PROPERTY,
	RESTIC_INSTANCE_NUM_PROPERTIES
};
static GParamSpec* restic_instance_properties[RESTIC_INSTANCE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define __vala_JsonNode_free0(var) ((var == NULL) ? NULL : (var = (_vala_JsonNode_free (var), NULL)))
enum  {
	RESTIC_INSTANCE_MESSAGE_SIGNAL,
	RESTIC_INSTANCE_FATAL_ERROR_SIGNAL,
	RESTIC_INSTANCE_NUM_SIGNALS
};
static guint restic_instance_signals[RESTIC_INSTANCE_NUM_SIGNALS] = {0};

struct _ToolInstance {
	GObject parent_instance;
	ToolInstancePrivate * priv;
};

struct _ToolInstanceClass {
	GObjectClass parent_class;
	gchar* (*_name) (ToolInstance* self);
	void (*_send_error) (ToolInstance* self, GError* e);
	gboolean (*_process_line) (ToolInstance* self, const gchar* stanza, const gchar* line, GError** error);
	gboolean (*_filter_env) (ToolInstance* self, const gchar* name);
};

struct _ResticInstance {
	ToolInstance parent_instance;
	ResticInstancePrivate * priv;
};

struct _ResticInstanceClass {
	ToolInstanceClass parent_class;
};

struct _ResticInstancePrivate {
	gboolean had_exit_error;
};

static gint ResticInstance_private_offset;
static gpointer restic_instance_parent_class = NULL;

VALA_EXTERN GType tool_instance_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GType restic_instance_get_type (void) G_GNUC_CONST ;
VALA_EXTERN gchar* _tool_instance_name (ToolInstance* self);
VALA_EXTERN void _tool_instance_send_error (ToolInstance* self,
                                GError* e);
VALA_EXTERN gboolean _tool_instance_filter_env (ToolInstance* self,
                                    const gchar* name);
VALA_EXTERN gboolean _tool_instance_process_line (ToolInstance* self,
                                      const gchar* stanza,
                                      const gchar* line,
                                      GError** error);
static gchar* restic_instance_real__name (ToolInstance* base);
static void restic_instance_real__send_error (ToolInstance* base,
                                       GError* e);
static gboolean restic_instance_real__filter_env (ToolInstance* base,
                                           const gchar* name);
static gboolean restic_instance_real__process_line (ToolInstance* base,
                                             const gchar* stanza,
                                             const gchar* line,
                                             GError** error);
static JsonNode* _vala_JsonNode_copy (JsonNode* self);
static void restic_instance_handle_exit_error (ResticInstance* self,
                                        JsonReader* reader);
static void _vala_JsonNode_free (JsonNode* self);
static void restic_instance_process_exit_error (ResticInstance* self,
                                         gint code,
                                         const gchar* message);
static void restic_instance_handle_exit (ResticInstance* self,
                                  gint code);
VALA_EXTERN ResticInstance* restic_instance_new (void);
VALA_EXTERN ResticInstance* restic_instance_construct (GType object_type);
VALA_EXTERN ToolInstance* tool_instance_construct (GType object_type);
static void g_cclosure_user_marshal_VOID__STRING_OBJECT (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__INT_STRING (GClosure * closure,
                                               GValue * return_value,
                                               guint n_param_values,
                                               const GValue * param_values,
                                               gpointer invocation_hint,
                                               gpointer marshal_data);
static GObject * restic_instance_constructor (GType type,
                                       guint n_construct_properties,
                                       GObjectConstructParam * construct_properties);
static void _restic_instance_handle_exit_tool_instance_exited (ToolInstance* _sender,
                                                        gint code,
                                                        gpointer self);
static void restic_instance_finalize (GObject * obj);
static GType restic_instance_get_type_once (void);

static inline gpointer
restic_instance_get_instance_private (ResticInstance* self)
{
	return G_STRUCT_MEMBER_P (self, ResticInstance_private_offset);
}

static gchar*
restic_instance_real__name (ToolInstance* base)
{
	ResticInstance * self;
	gchar* _tmp0_;
	gchar* result;
#line 32 "../libdeja/restic/ResticInstance.vala"
	self = (ResticInstance*) base;
#line 34 "../libdeja/restic/ResticInstance.vala"
	_tmp0_ = g_strdup ("restic");
#line 34 "../libdeja/restic/ResticInstance.vala"
	result = _tmp0_;
#line 34 "../libdeja/restic/ResticInstance.vala"
	return result;
#line 174 "ResticInstance.c"
}

static void
restic_instance_real__send_error (ToolInstance* base,
                                  GError* e)
{
	ResticInstance * self;
	const gchar* _tmp0_;
#line 37 "../libdeja/restic/ResticInstance.vala"
	self = (ResticInstance*) base;
#line 37 "../libdeja/restic/ResticInstance.vala"
	g_return_if_fail (e != NULL);
#line 39 "../libdeja/restic/ResticInstance.vala"
	_tmp0_ = e->message;
#line 39 "../libdeja/restic/ResticInstance.vala"
	g_signal_emit (self, restic_instance_signals[RESTIC_INSTANCE_FATAL_ERROR_SIGNAL], 0, RESTIC_INSTANCE_ERROR_GENERIC, _tmp0_);
#line 191 "ResticInstance.c"
}

static gboolean
restic_instance_real__filter_env (ToolInstance* base,
                                  const gchar* name)
{
	ResticInstance * self;
	gboolean result;
#line 42 "../libdeja/restic/ResticInstance.vala"
	self = (ResticInstance*) base;
#line 42 "../libdeja/restic/ResticInstance.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 46 "../libdeja/restic/ResticInstance.vala"
	result = !g_str_has_prefix (name, "RESTIC_");
#line 46 "../libdeja/restic/ResticInstance.vala"
	return result;
#line 208 "ResticInstance.c"
}

static JsonNode*
_vala_JsonNode_copy (JsonNode* self)
{
#line 60 "../libdeja/restic/ResticInstance.vala"
	return g_boxed_copy (json_node_get_type (), self);
#line 216 "ResticInstance.c"
}

static gpointer
__vala_JsonNode_copy0 (gpointer self)
{
#line 60 "../libdeja/restic/ResticInstance.vala"
	return self ? _vala_JsonNode_copy (self) : NULL;
#line 224 "ResticInstance.c"
}

static void
_vala_JsonNode_free (JsonNode* self)
{
#line 76 "../libdeja/restic/ResticInstance.vala"
	g_boxed_free (json_node_get_type (), self);
#line 232 "ResticInstance.c"
}

static gboolean
restic_instance_real__process_line (ToolInstance* base,
                                    const gchar* stanza,
                                    const gchar* line,
                                    GError** error)
{
	ResticInstance * self;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean is_stanza = FALSE;
	JsonParser* parser = NULL;
	JsonParser* _tmp3_;
	JsonParser* _tmp4_;
	JsonNode* root = NULL;
	JsonParser* _tmp6_;
	JsonNode* _tmp7_;
	JsonNode* _tmp8_;
	JsonReader* reader = NULL;
	JsonNode* _tmp9_;
	JsonReader* _tmp10_;
	gchar* msgid = NULL;
	JsonReader* _tmp11_;
	JsonReader* _tmp15_;
	const gchar* _tmp16_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 49 "../libdeja/restic/ResticInstance.vala"
	self = (ResticInstance*) base;
#line 49 "../libdeja/restic/ResticInstance.vala"
	g_return_val_if_fail (stanza != NULL, FALSE);
#line 49 "../libdeja/restic/ResticInstance.vala"
	g_return_val_if_fail (line != NULL, FALSE);
#line 52 "../libdeja/restic/ResticInstance.vala"
	if (g_str_has_prefix (line, "{")) {
#line 52 "../libdeja/restic/ResticInstance.vala"
		_tmp1_ = g_str_has_suffix (line, "}");
#line 271 "ResticInstance.c"
	} else {
#line 52 "../libdeja/restic/ResticInstance.vala"
		_tmp1_ = FALSE;
#line 275 "ResticInstance.c"
	}
#line 52 "../libdeja/restic/ResticInstance.vala"
	if (_tmp1_) {
#line 52 "../libdeja/restic/ResticInstance.vala"
		_tmp0_ = TRUE;
#line 281 "ResticInstance.c"
	} else {
		gboolean _tmp2_ = FALSE;
#line 53 "../libdeja/restic/ResticInstance.vala"
		if (g_str_has_prefix (line, "[")) {
#line 53 "../libdeja/restic/ResticInstance.vala"
			_tmp2_ = g_str_has_suffix (line, "]");
#line 288 "ResticInstance.c"
		} else {
#line 53 "../libdeja/restic/ResticInstance.vala"
			_tmp2_ = FALSE;
#line 292 "ResticInstance.c"
		}
#line 53 "../libdeja/restic/ResticInstance.vala"
		_tmp0_ = _tmp2_;
#line 296 "ResticInstance.c"
	}
#line 52 "../libdeja/restic/ResticInstance.vala"
	is_stanza = _tmp0_;
#line 54 "../libdeja/restic/ResticInstance.vala"
	if (!is_stanza) {
#line 55 "../libdeja/restic/ResticInstance.vala"
		result = TRUE;
#line 55 "../libdeja/restic/ResticInstance.vala"
		return result;
#line 306 "ResticInstance.c"
	}
#line 57 "../libdeja/restic/ResticInstance.vala"
	_tmp3_ = json_parser_new_immutable ();
#line 57 "../libdeja/restic/ResticInstance.vala"
	parser = _tmp3_;
#line 58 "../libdeja/restic/ResticInstance.vala"
	_tmp4_ = parser;
#line 58 "../libdeja/restic/ResticInstance.vala"
	json_parser_load_from_data (_tmp4_, stanza, (gssize) -1, &_inner_error0_);
#line 58 "../libdeja/restic/ResticInstance.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 318 "ResticInstance.c"
		gboolean _tmp5_ = FALSE;
#line 58 "../libdeja/restic/ResticInstance.vala"
		g_propagate_error (error, _inner_error0_);
#line 58 "../libdeja/restic/ResticInstance.vala"
		_g_object_unref0 (parser);
#line 58 "../libdeja/restic/ResticInstance.vala"
		return _tmp5_;
#line 326 "ResticInstance.c"
	}
#line 60 "../libdeja/restic/ResticInstance.vala"
	_tmp6_ = parser;
#line 60 "../libdeja/restic/ResticInstance.vala"
	_tmp7_ = json_parser_get_root (_tmp6_);
#line 60 "../libdeja/restic/ResticInstance.vala"
	_tmp8_ = __vala_JsonNode_copy0 (_tmp7_);
#line 60 "../libdeja/restic/ResticInstance.vala"
	root = _tmp8_;
#line 61 "../libdeja/restic/ResticInstance.vala"
	_tmp9_ = root;
#line 61 "../libdeja/restic/ResticInstance.vala"
	_tmp10_ = json_reader_new (_tmp9_);
#line 61 "../libdeja/restic/ResticInstance.vala"
	reader = _tmp10_;
#line 63 "../libdeja/restic/ResticInstance.vala"
	msgid = NULL;
#line 64 "../libdeja/restic/ResticInstance.vala"
	_tmp11_ = reader;
#line 64 "../libdeja/restic/ResticInstance.vala"
	if (json_reader_read_member (_tmp11_, "message_type")) {
#line 348 "ResticInstance.c"
		JsonReader* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_;
#line 65 "../libdeja/restic/ResticInstance.vala"
		_tmp12_ = reader;
#line 65 "../libdeja/restic/ResticInstance.vala"
		_tmp13_ = json_reader_get_string_value (_tmp12_);
#line 65 "../libdeja/restic/ResticInstance.vala"
		_tmp14_ = g_strdup (_tmp13_);
#line 65 "../libdeja/restic/ResticInstance.vala"
		_g_free0 (msgid);
#line 65 "../libdeja/restic/ResticInstance.vala"
		msgid = _tmp14_;
#line 362 "ResticInstance.c"
	}
#line 66 "../libdeja/restic/ResticInstance.vala"
	_tmp15_ = reader;
#line 66 "../libdeja/restic/ResticInstance.vala"
	json_reader_end_member (_tmp15_);
#line 71 "../libdeja/restic/ResticInstance.vala"
	_tmp16_ = msgid;
#line 71 "../libdeja/restic/ResticInstance.vala"
	if (g_strcmp0 (_tmp16_, "exit_error") == 0) {
#line 372 "ResticInstance.c"
		JsonReader* _tmp17_;
#line 72 "../libdeja/restic/ResticInstance.vala"
		_tmp17_ = reader;
#line 72 "../libdeja/restic/ResticInstance.vala"
		restic_instance_handle_exit_error (self, _tmp17_);
#line 378 "ResticInstance.c"
	} else {
		const gchar* _tmp18_;
		JsonReader* _tmp19_;
#line 74 "../libdeja/restic/ResticInstance.vala"
		_tmp18_ = msgid;
#line 74 "../libdeja/restic/ResticInstance.vala"
		_tmp19_ = reader;
#line 74 "../libdeja/restic/ResticInstance.vala"
		g_signal_emit (self, restic_instance_signals[RESTIC_INSTANCE_MESSAGE_SIGNAL], 0, _tmp18_, _tmp19_);
#line 388 "ResticInstance.c"
	}
#line 76 "../libdeja/restic/ResticInstance.vala"
	result = TRUE;
#line 76 "../libdeja/restic/ResticInstance.vala"
	_g_free0 (msgid);
#line 76 "../libdeja/restic/ResticInstance.vala"
	_g_object_unref0 (reader);
#line 76 "../libdeja/restic/ResticInstance.vala"
	__vala_JsonNode_free0 (root);
#line 76 "../libdeja/restic/ResticInstance.vala"
	_g_object_unref0 (parser);
#line 76 "../libdeja/restic/ResticInstance.vala"
	return result;
#line 402 "ResticInstance.c"
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
#line 1501 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1501 "glib-2.0.vapi"
	end = _tmp0_;
#line 1502 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1502 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1503 "glib-2.0.vapi"
		result = maxlen;
#line 1503 "glib-2.0.vapi"
		return result;
#line 425 "ResticInstance.c"
	} else {
		gchar* _tmp2_;
#line 1505 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1505 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1505 "glib-2.0.vapi"
		return result;
#line 434 "ResticInstance.c"
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
#line 1512 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1514 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 453 "ResticInstance.c"
	} else {
#line 1514 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 457 "ResticInstance.c"
	}
#line 1514 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1516 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 463 "ResticInstance.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1518 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1518 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1518 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 473 "ResticInstance.c"
	}
#line 1521 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 1522 "glib-2.0.vapi"
		offset = string_length + offset;
#line 1523 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 481 "ResticInstance.c"
	} else {
#line 1525 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= string_length, NULL);
#line 485 "ResticInstance.c"
	}
#line 1527 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 1528 "glib-2.0.vapi"
		len = string_length - offset;
#line 491 "ResticInstance.c"
	}
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
#line 1531 "glib-2.0.vapi"
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1531 "glib-2.0.vapi"
	result = _tmp3_;
#line 1531 "glib-2.0.vapi"
	return result;
#line 501 "ResticInstance.c"
}

static void
restic_instance_process_exit_error (ResticInstance* self,
                                    gint code,
                                    const gchar* message)
{
	gchar* user_message = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp4_;
#line 79 "../libdeja/restic/ResticInstance.vala"
	g_return_if_fail (self != NULL);
#line 79 "../libdeja/restic/ResticInstance.vala"
	g_return_if_fail (message != NULL);
#line 83 "../libdeja/restic/ResticInstance.vala"
	if (g_str_has_suffix (message, ": no space left on device")) {
#line 91 "../libdeja/restic/ResticInstance.vala"
		code = RESTIC_INSTANCE_ERROR_OUT_OF_SPACE;
#line 521 "ResticInstance.c"
	}
#line 95 "../libdeja/restic/ResticInstance.vala"
	_tmp0_ = g_strdup (message);
#line 95 "../libdeja/restic/ResticInstance.vala"
	user_message = _tmp0_;
#line 96 "../libdeja/restic/ResticInstance.vala"
	_tmp1_ = user_message;
#line 96 "../libdeja/restic/ResticInstance.vala"
	if (g_str_has_prefix (_tmp1_, "Fatal: ")) {
#line 531 "ResticInstance.c"
		const gchar* _tmp2_;
		gchar* _tmp3_;
#line 97 "../libdeja/restic/ResticInstance.vala"
		_tmp2_ = user_message;
#line 97 "../libdeja/restic/ResticInstance.vala"
		_tmp3_ = string_substring (_tmp2_, (glong) 7, (glong) -1);
#line 97 "../libdeja/restic/ResticInstance.vala"
		_g_free0 (user_message);
#line 97 "../libdeja/restic/ResticInstance.vala"
		user_message = _tmp3_;
#line 542 "ResticInstance.c"
	}
#line 99 "../libdeja/restic/ResticInstance.vala"
	_tmp4_ = user_message;
#line 99 "../libdeja/restic/ResticInstance.vala"
	g_signal_emit (self, restic_instance_signals[RESTIC_INSTANCE_FATAL_ERROR_SIGNAL], 0, code, _tmp4_);
#line 79 "../libdeja/restic/ResticInstance.vala"
	_g_free0 (user_message);
#line 550 "ResticInstance.c"
}

static void
restic_instance_handle_exit_error (ResticInstance* self,
                                   JsonReader* reader)
{
	gint32 code = 0;
	gchar* message = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp4_;
#line 102 "../libdeja/restic/ResticInstance.vala"
	g_return_if_fail (self != NULL);
#line 102 "../libdeja/restic/ResticInstance.vala"
	g_return_if_fail (reader != NULL);
#line 104 "../libdeja/restic/ResticInstance.vala"
	json_reader_read_member (reader, "code");
#line 105 "../libdeja/restic/ResticInstance.vala"
	code = (gint32) json_reader_get_int_value (reader);
#line 106 "../libdeja/restic/ResticInstance.vala"
	json_reader_end_member (reader);
#line 108 "../libdeja/restic/ResticInstance.vala"
	json_reader_read_member (reader, "message");
#line 109 "../libdeja/restic/ResticInstance.vala"
	_tmp0_ = json_reader_get_string_value (reader);
#line 109 "../libdeja/restic/ResticInstance.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 109 "../libdeja/restic/ResticInstance.vala"
	message = _tmp1_;
#line 110 "../libdeja/restic/ResticInstance.vala"
	_tmp2_ = message;
#line 110 "../libdeja/restic/ResticInstance.vala"
	if (_tmp2_ == NULL) {
#line 585 "ResticInstance.c"
		gchar* _tmp3_;
#line 111 "../libdeja/restic/ResticInstance.vala"
		_tmp3_ = g_strdup ("");
#line 111 "../libdeja/restic/ResticInstance.vala"
		_g_free0 (message);
#line 111 "../libdeja/restic/ResticInstance.vala"
		message = _tmp3_;
#line 593 "ResticInstance.c"
	}
#line 112 "../libdeja/restic/ResticInstance.vala"
	json_reader_end_member (reader);
#line 114 "../libdeja/restic/ResticInstance.vala"
	self->priv->had_exit_error = TRUE;
#line 115 "../libdeja/restic/ResticInstance.vala"
	_tmp4_ = message;
#line 115 "../libdeja/restic/ResticInstance.vala"
	restic_instance_process_exit_error (self, (gint) code, _tmp4_);
#line 102 "../libdeja/restic/ResticInstance.vala"
	_g_free0 (message);
#line 605 "ResticInstance.c"
}

static void
restic_instance_handle_exit (ResticInstance* self,
                             gint code)
{
	gboolean _tmp0_ = FALSE;
#line 118 "../libdeja/restic/ResticInstance.vala"
	g_return_if_fail (self != NULL);
#line 120 "../libdeja/restic/ResticInstance.vala"
	if (code == 0) {
#line 120 "../libdeja/restic/ResticInstance.vala"
		_tmp0_ = TRUE;
#line 619 "ResticInstance.c"
	} else {
#line 120 "../libdeja/restic/ResticInstance.vala"
		_tmp0_ = self->priv->had_exit_error;
#line 623 "ResticInstance.c"
	}
#line 120 "../libdeja/restic/ResticInstance.vala"
	if (_tmp0_) {
#line 121 "../libdeja/restic/ResticInstance.vala"
		return;
#line 629 "ResticInstance.c"
	}
#line 129 "../libdeja/restic/ResticInstance.vala"
	if (code > 1) {
#line 130 "../libdeja/restic/ResticInstance.vala"
		restic_instance_process_exit_error (self, code, _ ("Failed with an unknown error."));
#line 635 "ResticInstance.c"
	}
}

ResticInstance*
restic_instance_construct (GType object_type)
{
	ResticInstance * self = NULL;
#line 9 "../libdeja/restic/ResticInstance.vala"
	self = (ResticInstance*) tool_instance_construct (object_type);
#line 9 "../libdeja/restic/ResticInstance.vala"
	return self;
#line 647 "ResticInstance.c"
}

ResticInstance*
restic_instance_new (void)
{
#line 9 "../libdeja/restic/ResticInstance.vala"
	return restic_instance_construct (TYPE_RESTIC_INSTANCE);
#line 655 "ResticInstance.c"
}

static void
g_cclosure_user_marshal_VOID__STRING_OBJECT (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__STRING_OBJECT) (gpointer data1, const char* arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__STRING_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 9 "../libdeja/restic/ResticInstance.vala"
	g_return_if_fail (n_param_values == 3);
#line 9 "../libdeja/restic/ResticInstance.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 9 "../libdeja/restic/ResticInstance.vala"
		data1 = closure->data;
#line 9 "../libdeja/restic/ResticInstance.vala"
		data2 = param_values->data[0].v_pointer;
#line 680 "ResticInstance.c"
	} else {
#line 9 "../libdeja/restic/ResticInstance.vala"
		data1 = param_values->data[0].v_pointer;
#line 9 "../libdeja/restic/ResticInstance.vala"
		data2 = closure->data;
#line 686 "ResticInstance.c"
	}
#line 9 "../libdeja/restic/ResticInstance.vala"
	callback = (GMarshalFunc_VOID__STRING_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 9 "../libdeja/restic/ResticInstance.vala"
	callback (data1, g_value_get_string (param_values + 1), g_value_get_object (param_values + 2), data2);
#line 692 "ResticInstance.c"
}

static void
g_cclosure_user_marshal_VOID__INT_STRING (GClosure * closure,
                                          GValue * return_value,
                                          guint n_param_values,
                                          const GValue * param_values,
                                          gpointer invocation_hint,
                                          gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT_STRING) (gpointer data1, gint arg_1, const char* arg_2, gpointer data2);
	register GMarshalFunc_VOID__INT_STRING callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 9 "../libdeja/restic/ResticInstance.vala"
	g_return_if_fail (n_param_values == 3);
#line 9 "../libdeja/restic/ResticInstance.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 9 "../libdeja/restic/ResticInstance.vala"
		data1 = closure->data;
#line 9 "../libdeja/restic/ResticInstance.vala"
		data2 = param_values->data[0].v_pointer;
#line 717 "ResticInstance.c"
	} else {
#line 9 "../libdeja/restic/ResticInstance.vala"
		data1 = param_values->data[0].v_pointer;
#line 9 "../libdeja/restic/ResticInstance.vala"
		data2 = closure->data;
#line 723 "ResticInstance.c"
	}
#line 9 "../libdeja/restic/ResticInstance.vala"
	callback = (GMarshalFunc_VOID__INT_STRING) (marshal_data ? marshal_data : cc->callback);
#line 9 "../libdeja/restic/ResticInstance.vala"
	callback (data1, g_value_get_int (param_values + 1), g_value_get_string (param_values + 2), data2);
#line 729 "ResticInstance.c"
}

static void
_restic_instance_handle_exit_tool_instance_exited (ToolInstance* _sender,
                                                   gint code,
                                                   gpointer self)
{
#line 29 "../libdeja/restic/ResticInstance.vala"
	restic_instance_handle_exit ((ResticInstance*) self, code);
#line 739 "ResticInstance.c"
}

static GObject *
restic_instance_constructor (GType type,
                             guint n_construct_properties,
                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ResticInstance * self;
#line 28 "../libdeja/restic/ResticInstance.vala"
	parent_class = G_OBJECT_CLASS (restic_instance_parent_class);
#line 28 "../libdeja/restic/ResticInstance.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 28 "../libdeja/restic/ResticInstance.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_RESTIC_INSTANCE, ResticInstance);
#line 29 "../libdeja/restic/ResticInstance.vala"
	g_signal_connect_object ((ToolInstance*) self, "exited", (GCallback) _restic_instance_handle_exit_tool_instance_exited, self, 0);
#line 28 "../libdeja/restic/ResticInstance.vala"
	return obj;
#line 760 "ResticInstance.c"
}

static void
restic_instance_class_init (ResticInstanceClass * klass,
                            gpointer klass_data)
{
#line 9 "../libdeja/restic/ResticInstance.vala"
	restic_instance_parent_class = g_type_class_peek_parent (klass);
#line 9 "../libdeja/restic/ResticInstance.vala"
	g_type_class_adjust_private_offset (klass, &ResticInstance_private_offset);
#line 9 "../libdeja/restic/ResticInstance.vala"
	((ToolInstanceClass *) klass)->_name = (gchar* (*) (ToolInstance*)) restic_instance_real__name;
#line 9 "../libdeja/restic/ResticInstance.vala"
	((ToolInstanceClass *) klass)->_send_error = (void (*) (ToolInstance*, GError*)) restic_instance_real__send_error;
#line 9 "../libdeja/restic/ResticInstance.vala"
	((ToolInstanceClass *) klass)->_filter_env = (gboolean (*) (ToolInstance*, const gchar*)) restic_instance_real__filter_env;
#line 9 "../libdeja/restic/ResticInstance.vala"
	((ToolInstanceClass *) klass)->_process_line = (gboolean (*) (ToolInstance*, const gchar*, const gchar*, GError**)) restic_instance_real__process_line;
#line 9 "../libdeja/restic/ResticInstance.vala"
	G_OBJECT_CLASS (klass)->constructor = restic_instance_constructor;
#line 9 "../libdeja/restic/ResticInstance.vala"
	G_OBJECT_CLASS (klass)->finalize = restic_instance_finalize;
#line 9 "../libdeja/restic/ResticInstance.vala"
	restic_instance_signals[RESTIC_INSTANCE_MESSAGE_SIGNAL] = g_signal_new ("message", TYPE_RESTIC_INSTANCE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_OBJECT, G_TYPE_NONE, 2, G_TYPE_STRING, json_reader_get_type ());
#line 9 "../libdeja/restic/ResticInstance.vala"
	restic_instance_signals[RESTIC_INSTANCE_FATAL_ERROR_SIGNAL] = g_signal_new ("fatal-error", TYPE_RESTIC_INSTANCE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_STRING, G_TYPE_NONE, 2, G_TYPE_INT, G_TYPE_STRING);
#line 787 "ResticInstance.c"
}

static void
restic_instance_instance_init (ResticInstance * self,
                               gpointer klass)
{
#line 9 "../libdeja/restic/ResticInstance.vala"
	self->priv = restic_instance_get_instance_private (self);
#line 26 "../libdeja/restic/ResticInstance.vala"
	self->priv->had_exit_error = FALSE;
#line 798 "ResticInstance.c"
}

static void
restic_instance_finalize (GObject * obj)
{
	ResticInstance * self;
#line 9 "../libdeja/restic/ResticInstance.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_RESTIC_INSTANCE, ResticInstance);
#line 9 "../libdeja/restic/ResticInstance.vala"
	G_OBJECT_CLASS (restic_instance_parent_class)->finalize (obj);
#line 809 "ResticInstance.c"
}

 G_GNUC_NO_INLINE static GType
restic_instance_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ResticInstanceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) restic_instance_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ResticInstance), 0, (GInstanceInitFunc) restic_instance_instance_init, NULL };
	GType restic_instance_type_id;
	restic_instance_type_id = g_type_register_static (TYPE_TOOL_INSTANCE, "ResticInstance", &g_define_type_info, 0);
	ResticInstance_private_offset = g_type_add_instance_private (restic_instance_type_id, sizeof (ResticInstancePrivate));
	return restic_instance_type_id;
}

GType
restic_instance_get_type (void)
{
	static gsize restic_instance_type_id__once = 0;
	if (g_once_init_enter (&restic_instance_type_id__once)) {
		GType restic_instance_type_id;
		restic_instance_type_id = restic_instance_get_type_once ();
		g_once_init_leave (&restic_instance_type_id__once, restic_instance_type_id);
	}
	return restic_instance_type_id__once;
}

